# -*- coding: utf-8 -*-
# ChatWindow.py
# generated by wxGlade 0.6.3 on Fri Feb 27 11:02:30 2009

import wx, sys, os
import ChatHtmlPanel as chm
import threading
from ChatTrayIcon import ChatTrayIcon
from refreshthread import *
import webbrowser
from about import AboutBox
from ChatLog import frmChatLog
from frmHelpU import frmHelp
from AnketaU import frmAnketa
from updateu import ChatUpdater
import common
from SettingsDlg import frmSettings
from PluginsWindow import frmPlugins
import chatlogdb as cldb
import plugins.base as base
from SmileyManager import SmManager

class ChatWindow(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: ChatWindow.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.Splitter = wx.SplitterWindow(self, -1, style=wx.SP_3D|wx.SP_BORDER)
        self.SplitterPnlRight = wx.Panel(self.Splitter, -1)
        self.SplitterPnlLeft = wx.Panel(self.Splitter, -1)
        self.LogFlag = False #При заходе - в лог не писать
        self.tskic = ChatTrayIcon(self)
        self.DialogLocked = False
        #TODO избавится от wx.HSCROLL(уже почти...)
        self.htmlMain = chm.ChatHtml(self.SplitterPnlLeft, -1)
        self.htmlOnline = chm.ChatHtml(self.SplitterPnlRight, -1, style=wx.html.HW_SCROLLBAR_NEVER)

        self.txtSay = wx.TextCtrl(self, -1, "", style=wx.TE_PROCESS_ENTER|wx.TE_MULTILINE|wx.TE_WORDWRAP)

        self.btnSay = wx.Button(self, wx.NewId(), u"Отправить")
        self.htmlSmileys = chm.ChatHtml(self, -1, style=wx.html.HW_SCROLLBAR_NEVER)
        self.SmileyManager = SmManager(self,self.htmlSmileys)
        self.frmChatWindow_statusbar = self.CreateStatusBar(3, wx.ST_SIZEGRIP)

        # Menu Bar
        self.frmChatWindow_menubar = wx.MenuBar()
        wxglade_tmp_menu = wx.Menu()
        self.miSettings = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), u"Параметры\tCtrl+S", u"Настройки программы", wx.ITEM_NORMAL)
        self.miSettings.SetBitmap(wx.Bitmap('pixmaps/menu/preferences.png'))

        wxglade_tmp_menu.AppendItem(self.miSettings)

        self.miLog = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), u"Лог\tCtrl+L", u"Просмотр лога", wx.ITEM_NORMAL)
        self.miLog.SetBitmap(wx.Bitmap('pixmaps/menu/log.png'))
        wxglade_tmp_menu.AppendItem(self.miLog)

        self.miPlugins = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), u"Плагины\tCtrl+P", u"Управление плагинами", wx.ITEM_NORMAL)
        self.miPlugins.SetBitmap(wx.Bitmap('pixmaps/menu/plugins.png'))
        wxglade_tmp_menu.AppendItem(self.miPlugins)

        wxglade_tmp_menu.AppendSeparator()
        self.miExit = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), u"Выход\tCtrl+Q", u"Выйти из программы", wx.ITEM_NORMAL)
        self.miExit.SetBitmap(wx.Bitmap('pixmaps/menu/exit.png'))
        self.miTurboExit = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), u"Аварийный выход\tCtrl+Alt+Z", u"Прибить", wx.ITEM_NORMAL)
        self.miTurboExit.SetBitmap(wx.Bitmap('pixmaps/menu/turboquit.png'))
        wxglade_tmp_menu.AppendItem(self.miExit)
        wxglade_tmp_menu.AppendItem(self.miTurboExit)
        self.frmChatWindow_menubar.Append(wxglade_tmp_menu, u"Управление")
        wxglade_tmp_menu = wx.Menu()
        self.miHelp = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), u"Содержание\tF1", "", wx.ITEM_NORMAL)
        self.miHelp.SetBitmap(wx.Bitmap('pixmaps/menu/help.png'))
        wxglade_tmp_menu.AppendItem(self.miHelp)
        wxglade_tmp_menu.AppendSeparator()
        self.miAbout = wx.MenuItem(wxglade_tmp_menu, wx.NewId(), u"О программе\tCtrl+O", "", wx.ITEM_NORMAL)
        self.miAbout.SetBitmap(wx.Bitmap('pixmaps/menu/about.png'))
        wxglade_tmp_menu.AppendItem(self.miAbout)
        self.frmChatWindow_menubar.Append(wxglade_tmp_menu, u"Помощь")
        self.SetMenuBar(self.frmChatWindow_menubar)
        # Menu Bar end
        self.__set_properties()
        self.__do_layout()
        self.__bind_events()
        # end wxGlade

        self.Worker = RefreshThread(self)

        common.ChatLog = cldb.ChatLogDB("chatlog.db")
        self.PluginManager = base.PluginManager(self)
        self.PluginManager.InitPlugins()
        self.Worker.start()

    def SaveConfig(self):
        sz = self.GetSize()
        self.cfg.WriteInt("width", sz[0])
        self.cfg.WriteInt("height", sz[1])
        self.cfg.WriteInt("onlinewidth", self.GetSize()[0]-self.Splitter.GetSashPosition())
        self.cfg.WriteBool("maximized", self.IsMaximized())

    def LoadConfig(self):
        self.cfg = wx.Config('delphichat6')
        if self.cfg.Exists('width'):
            self.SetSize((self.cfg.ReadInt('width'), self.cfg.ReadInt('height')))
        else:
            self.SetSize((800, 600))
        if self.cfg.Exists('chatupdate'):
            common.ChatUpdateInterval = self.cfg.ReadInt('chatupdate')
        else:
            common.ChatUpdateInterval = 20
        if self.cfg.Exists('onlineupdate'):
            common.OnlineUpdateInterval = self.cfg.ReadInt('onlineupdate')
        else:
            common.OnlineUpdateInterval = 80
        if self.cfg.Exists('banlist'):
            banlist = self.cfg.Read("banlist")
            if banlist != '':
                common.BanList = banlist.split('\x09')

        if self.cfg.Exists('onlinewidth'):
            self.sashpos = self.cfg.ReadInt('onlinewidth')
        else:
            self.sashpos = 215

        if self.cfg.Exists('chatcolor'):
            common.ChatColor = self.cfg.Read('chatcolor')
        else:
            common.ChatColor = "#000000"
        self.txtSay.SetForegroundColour(common.ChatColor)

        if self.cfg.Exists('fontsize'):
            common.fontSize = self.cfg.ReadInt('fontsize')
        else:
            common.fontSize = 10

        self.txtSay.SetFont(wx.Font(common.fontSize, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.txtSay.SetForegroundColour(common.ChatColor)

        if self.cfg.Exists('mute'):
            common.sndMute = self.cfg.ReadBool('mute')
        else:
            common.sndMute = False
        if self.cfg.Exists('checkupdate'):
            common.CheckForUpdate = self.cfg.ReadBool('checkupdate')
        else:
            common.CheckForUpdate = True

        if self.cfg.Exists('dochatlog'):
            common.DoChatLog = self.cfg.ReadBool('dochatlog')
        else:
            common.DoChatLog = False


        if self.cfg.Exists('maximized'):
            self.Maximize(self.cfg.ReadBool('maximized'))


    def __set_properties(self):
        # begin wxGlade: ChatWindow.__set_properties
        self.quitflag = 0
        self.SetTitle("Delphi Chat 6")
        self.LoadConfig()
        #self.SetSize((800, 600))
        self.SetBackgroundColour(wx.Colour(230, 237, 246))
        _icon = wx.Icon("pixmaps/MAINICON.ico", wx.BITMAP_TYPE_ICO)
        self.SetIcon(_icon)
        self.htmlMain.SetPage('<body bgcolor=#EEEEEE>')

        self.htmlOnline.SetPage('<body bgcolor=#E1E1E1>')

        self.btnSay.SetMinSize((90, 80))
        self.htmlSmileys.SetMinSize((225, 80))

        #if "gtk2" in wx.PlatformInfo: ???
        self.htmlMain.SetStandardFonts(common.fontSize)
        self.htmlOnline.SetStandardFonts(common.fontSize)
        self.htmlSmileys.SetStandardFonts(3)
        self.frmChatWindow_statusbar.SetStatusWidths([180, 200, -1])
        self.txtSay.SetMaxLength(220)

        self.Splitter.SetSashSize(5)
        self.Splitter.SetSashGravity(1.0)
        self.Splitter.SetMinimumPaneSize(50)

        # statusbar fields
        threading._start_new_thread(common.CheckUpdate, (self,))
        frmChatWindow_statusbar_fields = ["", u"Новая строка: Ctrl+Enter", ""]
        for i in range(len(frmChatWindow_statusbar_fields)):
            self.frmChatWindow_statusbar.SetStatusText(frmChatWindow_statusbar_fields[i], i)

        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: ChatWindow.__do_layout
        szrMain = wx.BoxSizer(wx.VERTICAL)
        szrBottom = wx.BoxSizer(wx.HORIZONTAL)
        szrTop = wx.BoxSizer(wx.VERTICAL)
        szrTopRight = wx.BoxSizer(wx.VERTICAL)
        szrTopLeft = wx.BoxSizer(wx.VERTICAL)
        szrTopLeft.Add(self.htmlMain, 1, wx.EXPAND, 0)
        self.SplitterPnlLeft.SetSizer(szrTopLeft)
        szrTopRight.Add(self.htmlOnline, 1, wx.EXPAND, 0)
        self.SplitterPnlRight.SetSizer(szrTopRight)
        self.Splitter.SplitVertically(self.SplitterPnlLeft, self.SplitterPnlRight)
        self.Splitter.SetSashPosition(self.GetSize()[0]-self.sashpos)
        szrTop.Add(self.Splitter, 1, wx.EXPAND, 0)
        szrMain.Add(szrTop, 1, wx.EXPAND, 0)
        szrBottom.Add(self.txtSay, 1, wx.ALL|wx.EXPAND, 1)
        szrBottom.Add(self.btnSay, 0, wx.ALL|wx.ALIGN_RIGHT, 1)
        szrBottom.Add(self.htmlSmileys, 0, wx.ALL|wx.ALIGN_RIGHT, 1)
        szrMain.Add(szrBottom, 0, wx.EXPAND, 0)
        self.SetSizer(szrMain)
        self.Layout()
        self.Centre()
        self.txtSay.SetFocus()
        # end wxGlade

    def __bind_events(self):
        self.Bind(wx.EVT_CLOSE, self.OnClose)
        self.Bind(common.EVT_CHAT_NOTIFY_EVENT, self.NotyfyHandler)
        self.Bind(wx.EVT_MENU, self.OnSettings, id=self.miSettings.GetId())
        self.Bind(wx.EVT_MENU, self.OnLog, id=self.miLog.GetId())
        self.Bind(wx.EVT_MENU, self.OnPlugins, id=self.miPlugins.GetId())
        self.Bind(wx.EVT_MENU, self.tskic.OnTaskBarClose, id=self.miExit.GetId())
        self.Bind(wx.EVT_MENU, self.OnTurboQuit, id=self.miTurboExit.GetId())
        self.Bind(wx.EVT_MENU, self.OnAbout, id=self.miAbout.GetId())
        self.Bind(wx.EVT_MENU, self.OnGetHelp, id=self.miHelp.GetId())

        self.htmlMain.Bind(chm.EVT_CHAT_WINDOW_EVENT, self.OnChatWindow)
        self.htmlOnline.Bind(chm.EVT_CHAT_WINDOW_EVENT, self.OnChatWindow)
        self.htmlSmileys.Bind(chm.EVT_CHAT_WINDOW_EVENT, self.OnChatWindow)
        self.Bind(wx.EVT_BUTTON, self.OnSayClick, id=self.btnSay.GetId())

        self.txtSay.Bind(wx.EVT_KEY_DOWN, self.OnKeyPress)
        self.htmlSmileys.Bind(wx.EVT_MOUSEWHEEL, self.OnScrollSmileys)

        self.Bind(wx.EVT_ACTIVATE, self.OnActivate)

    def ReloadChat(self):
        common.ChatLSize = 0
        common.ChatLId = 0
        common.SndFlag = False
        self.LogFlag = False
        self.htmlMain.SetPage('<body bgcolor=#EEEEEE>')
        self.Worker.ForceChatRefresh()
        self.Worker.ForceOnlineRefresh()

    def OnPlugins(self, event):
        self.DialogLocked = True
        Plugins = frmPlugins(self, -1, "")
        Plugins.ShowModal()
        Plugins.Destroy()
        self.DialogLocked = False

    def OnLog(self, event):
        ChatLog = frmChatLog(self, -1, "")
        ChatLog.Show()
        ChatLog.Raise()

    def OnSettings(self, event):
        self.DialogLocked = True
        Settings = frmSettings(self, -1, "")
        Settings.ShowModal()
        Settings.Destroy()
        self.DialogLocked = False

    def OnActivate(self,evt):
        if self.quitflag == 0:
            self.tskic.ModifyIcon(False)
            self.ScrollHTML()

    def OnAbout(self,evt):
        self.DialogLocked = True
        frmAbout = AboutBox(None, -1, "")
        frmAbout.ShowModal()
        frmAbout.Destroy()
        self.DialogLocked = False

    def OnTurboQuit(self,evt):
        self.SaveConfig()
        self.tskic.Destroy()
        sys.exit()
#        self.quitflag = 1
#        self.SaveConfig()
#        self.tskic.Destroy()
#        self.Worker.event.set()

#        common.ChatLog.Destroy()
#        self.Destroy()

    def OnGetHelp(self,evt):
#        self.DialogLocked = True
#        dlg = wx.MessageDialog(self,
#         u'Для смены смайлов покрутите колесиком.\n\nДля отправки привата используйте правую\nкнопку мыши.\n\nShift+Click по ссылке копирует адрес в буфер.',
#         u'Помощь',
#            wx.OK | wx.ICON_INFORMATION)
#        dlg.ShowModal()
#        dlg.Destroy()
#        self.DialogLocked = False
        ChatHelp = frmHelp(self, -1, "")
        ChatHelp.Show()
        ChatHelp.Raise()

    def RotateSmileys(self, delta):
        self.SmileyManager.RotateSmileys(delta)

    def OnScrollSmileys(self, evt):
        self.RotateSmileys(-evt.m_wheelRotation/evt.m_wheelDelta)

    def OnKeyPress(self, event):
        key_code = event.GetKeyCode()
        if (key_code == wx.WXK_RETURN or key_code == wx.WXK_NUMPAD_ENTER) and not event.ControlDown():
            self.Say(self.txtSay.GetValue())
            return
        event.Skip()

    def DoResize(self,evt):
        self.ScrollHTML()

    def OnClose(self, event):
        if self.quitflag:
            self.Worker.event.set()
            threading._start_new_thread(common.Logout, (self,))
        else:
            self.Hide()

    def OnSayClick(self, event):
        self.Say(self.txtSay.GetValue())

    def Say(self,txtVal):
        #txtVal = self.txtSay.GetValue()
        if (txtVal != ''):
            self.Worker.SayText(txtVal)
            self.txtSay.SetValue('')
        else:
            #Обновить чат
            self.Worker.ForceOnlineRefresh()
            self.Worker.ForceChatRefresh()
        self.txtSay.SetFocus()

    def ScrollHTML(self, blockScroll = False):
        scrl = self.htmlMain.GetScrollRange(wx.VERTICAL)
        if not (self.GetRect().Contains(wx.GetMousePosition()) and blockScroll):
            self.htmlMain.Scroll(0,scrl)

    def CreateHomeLabel(self, text):
        self.homeLabel = wx.HyperlinkCtrl(self.frmChatWindow_statusbar, -1, url=common.homepage,label=text)
        self.homeLabel.SetToolTipString(tip=u"Перейти на страницу загрузки")
        labeltop = (self.frmChatWindow_statusbar.GetClientSizeTuple()[1] - self.homeLabel.GetCharHeight())/2
        self.homeLabel.Move((390,int(labeltop)))
        self.homeLabel.Bind(wx.EVT_HYPERLINK, self.OnhomeLabelClick)

    def OnhomeLabelClick(self, event):
        dlg = wx.MessageDialog(self, u"Обновить автоматически?\n(для перехода на страницу загрузки нажмите [Нет])",
                                   u"Обновление", style = wx.YES_NO | wx.CANCEL | wx.ICON_QUESTION)
        val = dlg.ShowModal()
        if val == wx.ID_YES:
            cu = ChatUpdater(self, '',common.ProxyAddr, common.ProxyPass)
            cu.start()
        elif val == wx.ID_NO:
            webbrowser.open(event.GetURL())


    def DestroyHomeLabel(self):
        self.homeLabel.Destroy()

    def NotyfyHandler(self, evt):
        self.ProcessNotyfyHandler(evt)

    def ProcessNotyfyHandler(self, evt):
        if (evt.type == common.NOTIFY_TAKTHREADDIES):
            self.SaveConfig()
            self.tskic.Destroy()
            common.ChatLog.Destroy()
            self.Destroy()
        elif (evt.type == common.NOTIFY_TAKSTATUS):
            self.frmChatWindow_statusbar.SetStatusText(evt.status, 0)
            self.ScrollHTML(True)
        elif (evt.type == common.NOTIFY_CHAT_OK):
            self.htmlMain.Freeze()
            if not evt.attr1 is None:
                self.htmlMain.AppendToPage(evt.attr1)
                if self.LogFlag:
                    common.ChatLog.PutMessage(evt.attr1, common.DoChatLog)
                self.LogFlag = True
            self.ScrollHTML()
            self.htmlMain.Thaw()

        elif (evt.type == common.NOTIFY_ONLINE_OK):
            if not evt.attr1 is None:
                self.htmlOnline.SetPage('<body bgcolor=#E1E1E1>%s</body>' % evt.attr1)
        elif (evt.type == common.MSG_TYPE_PRIVATE) or (evt.type == common.MSG_TYPE_PERSONAL):
            if not self.IsActive():
                self.tskic.ModifyIcon(True)
        elif (evt.type == common.NOTIFY_UPDATE):
            if evt.status!='':
                self.CreateHomeLabel(evt.status)

        elif (evt.type == common.NOTIFY_DOWNLOAD_START):
            self.DestroyHomeLabel()
            self.frmChatWindow_statusbar.SetStatusText(u"Начинаю обновление...", 2)

        elif (evt.type == common.NOTIFY_DOWNLOAD_PROGRESS):
            self.frmChatWindow_statusbar.SetStatusText("Update...%d%%" % evt.percent, 2)

        elif (evt.type == common.NOTIFY_DOWNLOAD_END):
            if evt.error:
                dial = wx.MessageDialog(self, evt.emsg, u'Ошибка', wx.OK | wx.ICON_ERROR)
                dial.ShowModal()
            else:
                dial = wx.MessageDialog(self, u'Обновление завершено.\nПерезапустить программу?', u'Вопрос', wx.YES_NO | wx.ICON_QUESTION)
                if(dial.ShowModal()==wx.ID_YES):
#                    self.quitflag = 1
#                    self.Worker.event.set()

                    if ('linux' in sys.platform):
                        os.execl(wx.GetApp().path+'/delphichat','')
                    else:
                        os.system('delphichat.bat')
                    self.OnTurboQuit(None)

        elif(evt.type == common.NOTIFY_MSG_ENCODING_ERROR):
            self.txtSay.AppendText(u'[Недопустимые символы]: %s' % evt.attr1)
        elif(evt.type == common.NOTIFY_MSG_SEND_ERROR):
            lostmsg = unicode(evt.attr1, 'cp1251')
            dial = wx.MessageDialog(self, u'При отправке сообщения\n\n%s\n\nпроизошла ошибка.\nОтправить заново?' % lostmsg, u'Ошибка отправки сообщения', wx.YES_NO | wx.ICON_QUESTION)
            if(dial.ShowModal()==wx.ID_YES):
                self.Worker.SayText(lostmsg)
            else:
                self.txtSay.AppendText(u'[Ошибка соединения]: %s' % lostmsg)
        evt.Skip()

    def OnChatWindow(self, event):
        if event.type == chm.EVT_OBJECT_CLICK:
            fromto = self.txtSay.GetSelection()
            self.txtSay.Replace(fromto[0], fromto[1], event.data)
        elif event.type == chm.EVT_NICK_CLICK:
            sVal = self.txtSay.GetValue()
            sVal = '%s %s' % (event.data, sVal)
            self.txtSay.SetValue(sVal)
        elif event.type == chm.EVT_ANKETA_CLICK:
            Anketa = frmAnketa(self, -1, "")
            Anketa.SetNumber(event.data)
            Anketa.Show()
            Anketa.Raise()

        self.txtSay.SetInsertionPointEnd()
        self.txtSay.SetFocus()
# end of class ChatWindow


