﻿# -*- coding" utf-8 -*-
import wx

mainpack = {
"page":"main",
"target":"smile",
"caption":u"Основные",
"path":"pixmaps/smileys/",
"prefix":"",
"smileys":[
        [],
        [ "smile", "wink", "laugh", "rotate", "yes", "no", "bye", "kiss", "eek", "fie" ],
        [ "hi", "smoke", "tongue", "bow", "confused", "drink", "mad", "frown", "cry" ]
    ]
}
mainpack2 = {
"page":"advanced",
"target":"smile",
"caption":u"Дополнительные",
"path":"pixmaps/smileys/",
"prefix":"",
"smileys":[
        [],
        [ "kruto", "lol", "redface", "biggrin", "chaw", "shuffle", "amazed", "lady", "walkman" ],
        [ "beer", "idea", "dont", "super" ]
    ]
}

class SmilePopupMenu(wx.Menu):
    def __init__(self, parent):
        wx.Menu.__init__(self)
        self.smileyhtml = parent.smileyhtml
        self.sm = parent
        for item in parent.pages:
            mItem = wx.MenuItem(self, wx.NewId(), item["caption"])
            self.AppendItem(mItem)
            self.Bind(wx.EVT_MENU, self.OnItem, id=mItem.GetId())

#    def Page2HTML(self, page):
#        result = ""
#        for line in self.pages[page]["smileys"]:
#            for smile in line:
#                result = result + \
#                    '<glink href="%s%s" target="%s"><img src="%s%s.gif"></glink>&nbsp;\n' \
#                        % (self.pages[page]["prefix"], smile, self.pages[page]["target"], \
#                            self.pages[page]["path"], smile)
#            result = result + "<br>"
#        return "<body bgcolor=#EEEEEE><br><center>%s</center></body>" % result

    def OnItem(self, event):
        menu = event.GetEventObject()
        itemindex = menu.MenuItems.index(menu.FindItemById(event.GetId()))
        self.sm.page = itemindex
        self.smileyhtml.SetPage(self.sm.Page2HTML(itemindex))

class SmManager:
    def __init__(self,parent,smileyhtml):
        self.parent = parent
        self.smileyhtml = smileyhtml #htmlwindow
        self.pages = []
        self.page = 0
        self.AddPage(mainpack)
        self.AddPage(mainpack2)
        self.smileyhtml.Bind(wx.EVT_RIGHT_DOWN, self.OnSmileysRightDown)
        self.RotateSmileys()
        #self.PopupMenu = SmilePopupMenu(self.smileyhtml,self.pages)

    def Page2HTML(self, page):
        result = ""
        for line in self.pages[page]["smileys"]:
            for smile in line:
                result = result + \
                    '<glink href="%s" target="%s"><img src="%s%s.gif"></glink>&nbsp;\n' \
                        % (smile, self.pages[page]["target"], self.pages[page]["path"], smile)
            result = result + "<br>"
        return '<body bgcolor=#EEEEEE><br><center>%s</center></body>' % result

    def RotateSmileys(self, delta = 0):
        self.page = self.page + delta
        if self.page > len(self.pages)-1:
            self.page = 0
        if self.page < 0:
            self.page = len(self.pages)-1
        self.smileyhtml.SetPage(self.Page2HTML(self.page))

    def AddPage(self, page):
        self.pages.append(page)

    def DeletePage(self,page):
        try:
            self.pages.remove(page)
        except:
            pass

    def OnSmileysRightDown(self,event):
        self.smileyhtml.PopupMenu(SmilePopupMenu(self), event.GetPosition())




