# -*- coding: utf-8 -*-
# common.py

import  wx.lib.newevent
from socketm import *
import re, urllib, os
import glink
from soundu import PlaySound
from log import DoLog, debptint

ChatUpdateInterval = 0
OnlineUpdateInterval = 0
ChatColor = '#000000'
fontSize = 0
BanList = []
ChatURL = "http://www.delphimaster.ru/cgi-bin/chat2.pl"
ChatAnketa = "http://www.delphimaster.ru/cgi-bin/client.pl?anketa=%s"
CheckForUpdate = True
sndMute = False

debugui = False
version = '0.5.4'
homepage = 'http://k210.org/delphichat6/'

NOTIFY_TAKSTATUS = 66
NOTIFY_TAKEVENT = 13
NOTIFY_TAKTHREADDIES = 14

NOTIFY_LOGGING_IN = 1;
NOTIFY_LOGIN_FAILED = 2;
NOTIFY_LOGIN_OK = 3;

NOTIFY_REFRESHING_ONLINE = 7
NOTIFY_ONLINE_FAILED = 8
NOTIFY_ONLINE_OK = 9

NOTIFY_REFRESHING_CHAT = 10
NOTIFY_CHAT_FAILED = 11
NOTIFY_CHAT_OK = 12
NOTIFY_MSG_ENCODING_ERROR = 15
NOTIFY_MSG_SEND_ERROR = 16
NOTIFY_ANKETA_OK = 17
NOTIFY_ANKETA_FAILED = 18

NOTIFY_UPDATE = 100
NOTIFY_DOWNLOAD_START = 101
NOTIFY_DOWNLOAD_PROGRESS = 102
NOTIFY_DOWNLOAD_END = 103

MSG_TYPE_ARRIVE = 1
MSG_TYPE_LEAVE = 2
MSG_TYPE_PERSONAL = 3
MSG_TYPE_PRIVATE = 4
MSG_TYPE_OTHER = 5

ChatNotifyEvent, EVT_CHAT_NOTIFY_EVENT = wx.lib.newevent.NewEvent()

#SmileyPages = ['main', 'advanced', 'nafig', 'sleep', 'drinking', 'pom', 'whois', 'old', 'dozor', 'velo', 'kettle', 'pooh']
#SmileyPage = 0

SndFlag = False #При заходе - не играть!
DoChatLog = True #Вести лог
ChatLog = None #Chat log class

ChatId = ''
ChatLSize = 0
ChatLId = 0
UserName = ''
UserPassword = ''
ProxyAddr = ''
ProxyPass = ''

def CheckUpdate(_notify_window):
    result = ''
    if CheckForUpdate:
        upd = GetPage("GET","http://k210.org/downloads/files/chat6/version.txt","","",ProxyAddr,ProxyPass,version)
        rVersion = upd['content'].strip()
        debptint('rVersion: %s' % rVersion, 5)
        if (rVersion != version) and 0<len(rVersion)<10:
            result =  u"Доступна новая версия [%s]" % rVersion
    evt = ChatNotifyEvent(type=NOTIFY_UPDATE, status=result)
    wx.PostEvent(_notify_window, evt)

def GetAnketa(_notify_window, number):
    anketa = GetPage("GET",ChatAnketa % number,"","",ProxyAddr,ProxyPass,version)
    if anketa['status']==200:
        evt = ChatNotifyEvent(type=NOTIFY_ANKETA_OK, data=anketa['content'])
    else:
        evt = ChatNotifyEvent(type=NOTIFY_ANKETA_FAILED, data=u"Неверный запрос [%s]" % anketa['status'])
    wx.PostEvent(_notify_window, evt)

def Login(_notify_window):
    global ChatId, UserName, UserPassword, ChatColor
    SendStatus(_notify_window,'Logging in...')
    UserName = UserName.encode("cp1251")

    UserPassword = UserPassword.encode("cp1251")
    m = re.match('(?i)#[0-9A-F]{6}$',ChatColor)
    if not m:
        ChatColor = "#000000"
    ChatColor = ChatColor.upper()
    #Заглушка
    if(debugui):
        login_page = {'status': 302, "cookie": 'chatid=0;' }
    else:
        login_page = GetPage("POST",ChatURL,"",{"name":UserName,"topsw":UserPassword,"enter":"Войти в чат!"},ProxyAddr,ProxyPass,version)
    #Заглушка

    if (login_page['status'] != 302):
        SendStatus(_notify_window,"Login error [expected 302 but %d found]"%login_page['status'])

        if login_page['status']==200:
            SendStatus(_notify_window,u"Неверные учетные данные")
        evt = ChatNotifyEvent(type=NOTIFY_LOGIN_FAILED)
        wx.PostEvent(_notify_window, evt)
    else:
        ChatId = GetChatId(login_page['cookie'])
        if (ChatId == ''):
            SendStatus(_notify_window,"Unable parse chatid [ERROR]")
            evt = ChatNotifyEvent(type=NOTIFY_LOGIN_FAILED)
            wx.PostEvent(_notify_window, evt)
        else:
            SendStatus(_notify_window,"Login [OK] -> %s" % ChatId)
            debptint('ChatId: %s' % ChatId, 5)
            evt = ChatNotifyEvent(type=NOTIFY_LOGIN_OK)
            wx.PostEvent(_notify_window, evt)

def SendStatus(_notify_window, msg, params=0):
    debptint('SendStatus: %s' % msg, 5)
    evt = ChatNotifyEvent(type=NOTIFY_TAKSTATUS,status=msg)
    wx.PostEvent(_notify_window, evt)

def TryPlaySound(msgType):
    try:
        if not sndMute:
            PlaySound(msgType, SndFlag)
    except Exception, ex:
        print ex.message

def __parseNicks(msg):
    msgNick = re.search('top\.AddToPrivate\(\'(.+?)\'\)"><IMG',msg).group(1)
    if (msgNick in BanList):
        msgNickText = '<font color="red">%s [ban]</font>' % msgNick
    else:
        msgNickText = msgNick
    anketa = re.search('anketa.pl\?id=(.+?)"',msg).group(1)
    return '<glink href="%s" target="private"><img src="pixmaps/smileys/lock.gif">\
        </glink>&nbsp;<glink href="%s" target="nic">%s</glink> <glink href="%s" target="anketa">\
        &copy;</glink><br>' % (msgNick, msgNick, msgNickText, anketa)

def __ParseOnline(text):
    retval = ''
    text = unicode(text, 'cp1251')
    msgset = re.findall("top\.AddToPrivate.*?</a><BR>",text)

    for msg in msgset:
        try:
            retval+=__parseNicks(msg)
        except:
            DoLog('Can`t parse nic: %s' % msg)
            continue
    return retval

def LoadAndParseOnlineList(_notify_window):
    if (UserName == '') or (ChatId == ''):
        return ''

    #Заглушка
    if(debugui):
        f = open('debugui/playlist.pl')
        s = f.read()
        f.close()
        return __ParseOnline(s)
    #Заглушка
    cookiestr = "chat=%s; chatid=%s" % (UserName, ChatId)
    response = GetPage("GET",ChatURL,cookiestr, {"showonline":2},ProxyAddr,ProxyPass,version)
    if (response['status'] != 200):
        SendStatus(_notify_window,'[%d] Server Error.'% response['status'])
        return
    return __ParseOnline(response['content'])

def Logout(_notify_window):
    if (UserName == '') or (ChatId == ''):
        return
    if(debugui):
        evt = ChatNotifyEvent(type=NOTIFY_TAKTHREADDIES)
        wx.PostEvent(_notify_window, evt)
        return
    cookiestr = "chat=%s; chatid=%s" % (UserName, ChatId)
    response = GetPage("GET",ChatURL,cookiestr, {"exit":1},ProxyAddr,ProxyPass,version)
    evt = ChatNotifyEvent(type=NOTIFY_TAKTHREADDIES)
    wx.PostEvent(_notify_window, evt)

