# -*- coding: utf-8 -*-

import wx
import ChatHtmlPanel as chm
import common

class frmHelp(wx.Frame):
    def __init__(self, *args, **kwds):
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        self.parent = args[0]
        wx.Frame.__init__(self, *args, **kwds)
        self.htmlHelp = chm.ChatHtml(self, -1)
        self.statusbar = self.CreateStatusBar(1, wx.ST_SIZEGRIP)
        self.__set_properties()
        self.__do_layout()

    def __set_properties(self):
        self.SetTitle("Delphichat 6 [Help]")
        self.SetSize((560, 400))
        self.statusbar.SetStatusWidths([-1])
        self.htmlHelp.SetStandardFonts(common.fontSize)
        _icon = wx.EmptyIcon()
        _icon.CopyFromBitmap(wx.Bitmap("pixmaps/menu/help.png", wx.BITMAP_TYPE_ANY))
        self.SetIcon(_icon)
        statusbar_fields = ['']
        for i in range(len(statusbar_fields)):
            self.statusbar.SetStatusText(statusbar_fields[i], i)
        self.Bind(wx.EVT_CLOSE, self.OnClose)

#        f = open("help/index.html")
#        page = f.read()
#        f.close()
#        self.htmlHelp.SetPage(page)
        self.htmlHelp.LoadPage("help/index.html")

    def OnClose(self, event):
        self.Destroy()

    def __do_layout(self):
        sizer = wx.BoxSizer(wx.HORIZONTAL)
        sizer.Add(self.htmlHelp, 1, wx.EXPAND, 0)
        self.SetSizer(sizer)
        self.Layout()
        self.Centre()

# end of class frmChatLog
