# -*- coding: utf-8 -*-
# glink.py
import wx
import wx.html
from log import DoLog


class TagHandler(wx.html.HtmlWinTagHandler):
        tags = None
        def GetSupportedTags(self):
                return self.tags

        def HandleTag(self, tag):
                try:
                        return self.HandleTag2(tag)
                except Exception, e:
                        DoLog("Error occurred in handling tag [%s %s]" % (e.args, e.message))

        def HandleTag2(self, tag):
                return False

        @classmethod
        def clear(cls):
                pass

class GLinkTagHandler(TagHandler):
        tags = "GLINK"

        def HandleTag(self, tag):
                parser = self.GetParser()

                if tag.HasParam("HREF"):
                        oldclr = parser.GetActualColor()
                        oldfontbold = parser.GetFontBold()
                        name = tag.GetParam("HREF")

                        colour = "#000080"
                        target = ""
                        if tag.HasParam("COLOUR"):
                                colour = tag.GetParam("COLOUR")
                        if (tag.HasParam("TARGET")):
                            target = tag.GetParam("TARGET")

                        parser.SetActualColor(colour)

                        parser.GetContainer().InsertCell(wx.html.HtmlColourCell(colour))
                        parser.SetFontBold(True)
                        parser.GetContainer().InsertCell(
                                wx.html.HtmlFontCell(parser.CreateCurrentFont())
                        )
                        parser.SetLink(name +'\x09'+ target)

                        self.ParseInner(tag)

                        parser.SetLink("")
                        parser.SetFontBold(oldfontbold)
                        parser.GetContainer().InsertCell(
                                wx.html.HtmlFontCell(parser.CreateCurrentFont())
                        )
                        parser.SetActualColor(oldclr)
                        parser.GetContainer().InsertCell(wx.html.HtmlColourCell(oldclr))

                        return True
                return False

#class CheckTagHandler(TagHandler):
#        tags = "CHECK"

#        def HandleTag2(self, tag):
#                parser = self.GetParser()
#                label = ""
#                if tag.HasParam("label"):
#                        label = tag.GetParam("label")

#                parent = parser.GetWindowInterface().GetHTMLWindow()
#                assert parent
#                obj = wx.CheckBox(parent, label=label)#**self.ctx.kwargs)
#                obj.Show(True)

#                floatwidth = 0
#                parser.GetContainer().InsertCell(
#                                wx.html.HtmlWidgetCell(obj, floatwidth))

#                return True


#wx.html.HtmlWinParser_AddTagHandler(CheckTagHandler)
wx.html.HtmlWinParser_AddTagHandler(GLinkTagHandler)
