# -*- coding: utf-8 -*-
import os
import inspect



class Baselugin(object):
    def __init__(self, parent=None,modulename = '',active=False):
        self.modulename = modulename
        self.parentwindow = parent
        self.version = "v0.0"
        self.description = "No description"
        self.name = "Override me, pleace"
        self.active = False

    def SetActive(self,active = True):
        pass

    def IsActive(self):
        return self.active

    def Destroy(self):
        pass

class PluginManager(object):
    def __init__(self, parent):
    # Перебирем файлы в папке plugins
        self.plugin_dir = "plugins"
        self.parent = parent
        self.plugins = []
        self.enabledplugins=[]
        if self.parent.cfg.Exists("enabledplugins"):
            self.enabledplugins=self.parent.cfg.Read("enabledplugins").split(',')
        #self.InitPlugins()

    def SortPlugins(self,package_obj,modulename):
        module_obj = getattr (package_obj, modulename)
        # Перебираем все, что есть внутри модуля
        for elem in dir (module_obj):
            obj = getattr (module_obj, elem)
            # Это класс?
            if inspect.isclass (obj):
                # Класс производный от Baselugin?
                if issubclass (obj, Baselugin):
                    # Создаем экземпляр
                    self.plugins.append(obj(self.parent,modulename,modulename in self.enabledplugins))

    def ClearPlugins(self):
        #for pname in self.plugins:
            for pl in self.plugins:
                pl.SetActive(False)
                pl.Destroy()
            self.plugins=[]

    def InitPlugins(self):
        self.ClearPlugins()
        for fname in os.listdir(self.plugin_dir):
            # Нас интересуют только файлы с расширением .py
            if fname.endswith (".py"):
                # Обрежем расширение .py у имени файла
                module_name = fname[: -3]
                # Пропустим файлы py и __init__.py
                # _ - отключенные плагины
                if module_name != "base" and module_name != "__init__" and module_name[0]!="_":
                    #print "Load module %s" % module_name
                    # Загружаем модуль и добавляем его имя в список загруженных модулей
                    package_obj = __import__(self.plugin_dir + "." +  module_name)
                    self.SortPlugins(package_obj,module_name)
